#ifndef _CALIBRATION_H_
#define _CALIBRATION_H_

#include "system.h"
#include "io.h"

#define NO_CUE_DETECTED        (IORD_32DIRECT(VISION_BASE, 0) >> 31)

#define START_CALIBRATION      IOWR_32DIRECT(VISION_BASE, 4 * 4, 1)
#define STOP_CALIBRATION       IOWR_32DIRECT(VISION_BASE, 4 * 4, 0)
#define READ_REPOS_REG         IORD_32DIRECT(VISION_BASE, 3 * 4)
#define READ_CAMERA_START      IORD_32DIRECT(VISION_BASE, 1 * 4)
#define READ_CAMERA_END        IORD_32DIRECT(VISION_BASE, 2 * 4)

#define SET_CAMERA_SANDBOX_START_X(data)  \
                               IOWR_32DIRECT(VISION_BASE, 5 * 4, (data))
#define SET_CAMERA_SANDBOX_END_X(data)  \
                               IOWR_32DIRECT(VISION_BASE, 6 * 4, (data))
#define SET_CAMERA_SANDBOX_START_Y(data)  \
                               IOWR_32DIRECT(VISION_BASE, 7 * 4, (data))
#define SET_CAMERA_SANDBOX_END_Y(data)  \
                               IOWR_32DIRECT(VISION_BASE, 8 * 4, (data))

#define TABLE_START_HOZ_POS    140
#define TABLE_END_HOZ_POS      500
#define TABLE_START_VER_POS    120
#define TABLE_END_VER_POS      360

#define CAMERA_CROP_MARGIN_HOZ 10
#define CAMERA_CROP_MARGIN_VER 20
#define BLACK_MARGIN_HOZ       110
#define BLACK_MARGIN_VER       90

#define BLACK_MARGIN_CONFIG    ((BLACK_MARGIN_VER << 8) | BLACK_MARGIN_HOZ)
#define BLACK_MARGIN_REG       31
#define BLACK_MARGIN_SET(size) IOWR_16DIRECT(VGA_BASE, 31 * 2, size)

#define GREEN_COLUMN_THRESHOLD 120
#define GREEN_ROW_THRESHOLD    240

#define SET_GREEN_ROW_THR      IOWR_32DIRECT(VISION_BASE, 10 * 4, (GREEN_ROW_THRESHOLD))
#define SET_GREEN_COL_THR      IOWR_32DIRECT(VISION_BASE, 9 * 4, (GREEN_COLUMN_THRESHOLD))

void doCalibration();
int calibrate();

#endif /*CALIBRATION_H_*/
