--Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity vision is 
        port (
              -- inputs:
                 signal address : IN STD_LOGIC_VECTOR (4 DOWNTO 0);
                 signal chipselect : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal frame_valid : IN STD_LOGIC;
                 signal line_valid : IN STD_LOGIC;
                 signal pixel_clk : IN STD_LOGIC;
                 signal pixel_data : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal read : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal threshold : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal write : IN STD_LOGIC;
                 signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal cal_direction : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal master_clk : OUT STD_LOGIC;
                 signal no_detect : OUT STD_LOGIC;
                 signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal vision_flags : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity vision;


architecture europa of vision is
component avalon_vision is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (4 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal frame_valid : IN STD_LOGIC;
                    signal line_valid : IN STD_LOGIC;
                    signal pixel_clk : IN STD_LOGIC;
                    signal pixel_data : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal read : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal threshold : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal write : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal cal_direction : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal master_clk : OUT STD_LOGIC;
                    signal no_detect : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal vision_flags : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component avalon_vision;

                signal internal_cal_direction :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_master_clk :  STD_LOGIC;
                signal internal_no_detect :  STD_LOGIC;
                signal internal_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_vision_flags :  STD_LOGIC_VECTOR (7 DOWNTO 0);

begin

  --the_avalon_vision, which is an e_instance
  the_avalon_vision : avalon_vision
    port map(
      cal_direction => internal_cal_direction,
      master_clk => internal_master_clk,
      no_detect => internal_no_detect,
      readdata => internal_readdata,
      vision_flags => internal_vision_flags,
      address => address,
      chipselect => chipselect,
      clk => clk,
      frame_valid => frame_valid,
      line_valid => line_valid,
      pixel_clk => pixel_clk,
      pixel_data => pixel_data,
      read => read,
      reset_n => reset_n,
      threshold => threshold,
      write => write,
      writedata => writedata
    );


  --vhdl renameroo for output signals
  cal_direction <= internal_cal_direction;
  --vhdl renameroo for output signals
  master_clk <= internal_master_clk;
  --vhdl renameroo for output signals
  no_detect <= internal_no_detect;
  --vhdl renameroo for output signals
  readdata <= internal_readdata;
  --vhdl renameroo for output signals
  vision_flags <= internal_vision_flags;

end europa;

